(** Time-stamp: <modified the 11/03/2009 (at 17:32) by Erwan Jahier> *)


val string_of_node_key_rec : Eff.node_key -> string
val node_of_node_exp_eff: Eff.node_exp -> string

val string_of_const_eff : Eff.const -> string
val string_of_leff : Eff.left -> string

val string_of_type_eff : Eff.type_ -> string
val string_of_type_eff4msg : Eff.type_ -> string
val string_of_type_eff_list : Eff.type_ list -> string
val string_of_type_eff_list4msg : Eff.type_ list -> string
val type_eff_list_to_string :Eff.type_ list -> string

val type_decl: Ident.long -> Eff.type_ -> string
val const_decl: Ident.long -> Eff.const -> string

val string_of_var_info_eff: Eff.var_info -> string
val string_of_var_info_eff4msg: Eff.var_info -> string
val type_string_of_var_info_eff: Eff.var_info -> string
val type_string_of_var_info_eff4msg: Eff.var_info -> string
val string_of_slice_info_eff : Eff.slice_info -> string 



(* Dump all the aliases that were introduced during the compilation process *)
val dump_type_alias : out_channel -> unit


(* used for error msgs *)
val string_of_clock_exp : SyntaxTreeCore.clock_exp -> string
val string_of_clock2  : Eff.clock -> string
val string_of_val_exp_eff : Eff.val_exp -> string
val string_of_val_exp_eff_core : Eff.val_exp_core -> string

(* dump Eff.local_env *)
val dump_local_env : Eff.local_env -> unit
